#include <string.h>

#include "relic_bc.h"
#include "relic_bc_low.h"
#include "relic_error.h"

void bc_init(bc_ctx_t ctx, unsigned char *iv, size_t iv_len) {
	if (iv_len != BC_BLOCK_LEN) {
		THROW(ERR_NO_VALID);
	}
	memcpy(ctx->iv, iv, iv_len);
}

void bc_ctr_enc(bc_ctx_t ctx, unsigned char *cipher, unsigned char *msg, size_t len) {
	bc_t t;
	bc_enc_start(ctx, t, ctx->iv);
	bc_inc32_low(ctx->iv);
	bc_enc_end(ctx, t);
	if (len < BC_BLOCK_LEN) {
		bc_nxor_low(cipher, msg, t, len);
	} else {
		bc_xor_low(cipher, msg, t);
	}
}
