#include "relic_bc.h"
#include "relic_bc_low.h"

#include "relic_util.h"

void bc_xor_low(bc_t c, bc_t a, bc_t b) {
	bc_nxor_low(c, a, b, BC_BLOCK_LEN);
}

void bc_nxor_low(unsigned char *c, unsigned char *a, unsigned char *b, size_t n) {
	int i;

	for (i = 0; i < n; i++, a++, b++, c++) {
		(*c) = (*a) ^ (*b);
	}
}

void bc_inc32_low(bc_t block) {
	uint32_t d;
	memcpy(&d, block + BC_BLOCK_LEN - sizeof(uint32_t), sizeof(uint32_t));
	d = util_conv_big(d);
	d += 1;
	d = util_conv_big(d);
	memcpy(block + BC_BLOCK_LEN - sizeof(uint32_t), &d, sizeof(uint32_t));
}
