/*
 * RELIC is an Efficient LIbrary for Cryptography
 * Copyright (C) 2007-2012 RELIC Authors
 *
 * This file is part of RELIC. RELIC is legal property of its developers,
 * whose names are not listed here. Please refer to the COPYRIGHT file
 * for contact information.
 *
 * RELIC is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * RELIC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with RELIC. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @file
 *
 * Implementation of the low-level authenticated cipher OCB3 functions.
 *
 * @version $Id$
 * @ingroup ac
 */

#include <msp430.h>

#include "relic_bc_conf.h"

NAME relic_bc_ocb_asm
RSEG CODE
EVEN

PUBLIC ac_ocb3_dbl_low
PUBLIC ac_ocb3_ntz_low

/*============================================================================*/
/* Public definitions                                                         */
/*============================================================================*/

RSEG CODE:CODE:REORDER:NOROOT(1)
ac_ocb3_dbl_low:
    rla 2*7(r12)
    rlc 2*6(r12)
    rlc 2*5(r12)
    rlc 2*4(r12)
    rlc 2*3(r12)
    rlc 2*2(r12)
    rlc 2*1(r12)
    rlc 2*0(r12)
    jnc skip
    xor #135,2*7(r12)
skip:
    reta

RSEG CODE:CODE:REORDER:NOROOT(1)
ac_ocb3_ntz_low:
    clr r13
    setc
back:
    rrc r12
    jc res0
    rrc r12
    jc res1
    rrc r12
    jc res2
    rrc r12
    jc res3
    rrc r12
    jc res4
    rrc r12
    jc res5
    rrc r12
    jc res6
    rrc r12
    jc res7
    add #8,r13
    jmp back

res7:
    inc r13
res6:
    inc r13
res5:
    inc r13
res4:
    inc r13
res3:
    inc r13
res2:
    inc r13
res1:
    inc r13
res0:
    mov r13,r12
    reta

END
