/*
 * RELIC is an Efficient LIbrary for Cryptography
 * Copyright (C) 2007-2012 RELIC Authors
 *
 * This file is part of RELIC. RELIC is legal property of its developers,
 * whose names are not listed here. Please refer to the COPYRIGHT file
 * for contact information.
 *
 * RELIC is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * RELIC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with RELIC. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @file
 *
 * Implementation of the low-level block cipher utility functions.
 *
 * @version $Id$
 * @ingroup bc
 */

#include "relic_bc_conf.h"

#ifndef MSP430X
#define reta ret
#define RETA ret
#define calla call
#define CALLA call
#endif

NAME relic_bc_util_low_asm
RSEG CODE
EVEN

PUBLIC bc_xor_low
PUBLIC bc_inc32_low

/*============================================================================*/
/* Public definitions                                                         */
/*============================================================================*/

RSEG CODE:CODE:REORDER:NOROOT(1)
bc_xor_low:
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*0(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*1(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*2(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*3(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*4(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*5(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*6(r12)
    mov @r13+,r15
    xor @r14+,r15
    mov r15,2*7(r12)
    reta

RSEG CODE:CODE:REORDER:NOROOT(1)
bc_inc32_low:
    mov 2*6(r12),r13
    mov 2*7(r12),r14
    swpb r13
    swpb r14
    add #1,r14
    adc r13
    swpb r13
    swpb r14
    mov r13,2*6(r12)
    mov r14,2*7(r12)
    reta

END
