INDEX_READ_3 = r"""
    /* INDEX_READ_3 */
    mov @{a}+,r4
    swpb r4
    rrum #4,r4
    and #0xF,r4
"""

INDEX_READ_2 = r"""
    /* INDEX_READ_2 */
    mov @{a}+,r4
    swpb r4
    and #0xF,r4
"""

INDEX_READ_1 = r"""
    /* INDEX_READ_1 */
    mov @{a}+,r4
    rrum #4,r4
    and #0xF,r4
"""

INDEX_READ_0 = r"""
    /* INDEX_READ_0 */
    mov @{a}+,r4
    and #0xF,r4
"""

INDEX_MULT = INDEX_MULT_KARATSUBA = r"""
    /* INDEX_MULT */
    mov r4,@r1
    rlam #3,r4
    add @r1,r4
    rla r4

    add r13,r4
    add #{offset},r4
"""

INDEX_MULT_ALT = INDEX_MULT_KARATSUBA_ALT = r"""
    /* INDEX_MULT_ALT */
    mov r4,@r1
    rlam #3,r4
    add @r1,r4
    rla r4

    add r13,r4
    add #(2*9*16+{offset}),r4
"""

COL_WRITE_MOV = r"""
    /* COL_WRITE_MOV */
    mov {acci},{offset}({c})
"""

COL_WRITE_XOR = r"""
    /* COL_WRITE_XOR */
    xor {acci},{offset}({c})
"""

COL_I_XOR = r"""
    xor @r4+,{acci}
"""

COL_I_MOV = r"""
    mov @r4+,{acci}
"""

SHIFT_0 = r"""
    add @{c}+,-2({c})
"""

SHIFT = r"""
    addc @{c}+,-2({c})
"""

SHIFT_FAST_START = r"""
    clr r4
"""

SHIFT_FAST = r"""
    /* SHIFT_FAST */
    mov @{c}+,r5
    mov @{c}+,r6
    mov @{c}+,r7
    mov @{c}+,r8
    mov @{c}+,r9
    mov @{c}+,r10
    mov @{c}+,r11
    mov @{c}+,r12

    push r15

    swpb r5
    mov.b r5,r15
    xor r15,r5

    swpb r6
    mov.b r6,r4
    xor r4,r6
    bis r15,r6

    swpb r7
    mov.b r7,r15
    xor r15,r7
    bis r4,r7

    swpb r8
    mov.b r8,r4
    xor r4,r8
    bis r15,r8

    swpb r9
    mov.b r9,r15
    xor r15,r9
    bis r4,r9

    swpb r10
    mov.b r10,r4
    xor r4,r10
    bis r15,r10

    swpb r11
    mov.b r11,r15
    xor r15,r11
    bis r4,r11

    swpb r12
    mov.b r12,r4
    xor r4,r12
    bis r15,r12

    pop r15

    mov r5,-2*8({c})
    mov r6,-2*7({c})
    mov r7,-2*6({c})
    mov r8,-2*5({c})
    mov r9,-2*4({c})
    mov r10,-2*3({c})
    mov r11,-2*2({c})
    mov r12,-2*1({c})
"""

SHIFT_FAST_KARATSUBA = r"""
    /* SHIFT_FAST_KARATSUBA */
    add #2*7,{c}
    mov @{c}+,r4

    {xors}

    swpb r4
    mov.b r4,r4

    push r15

    swpb {acc[0]}
    mov.b {acc[0]},r15
    xor r15,{acc[0]}
    bis r4,{acc[0]}

    swpb {acc[1]}
    mov.b {acc[1]},r4
    xor r4,{acc[1]}
    bis r15,{acc[1]}

    swpb {acc[2]}
    mov.b {acc[2]},r15
    xor r15,{acc[2]}
    bis r4,{acc[2]}

    swpb {acc[3]}
    mov.b {acc[3]},r4
    xor r4,{acc[3]}
    bis r15,{acc[3]}

    swpb {acc[4]}
    mov.b {acc[4]},r15
    xor r15,{acc[4]}
    bis r4,{acc[4]}

    swpb {acc[5]}
    mov.b {acc[5]},r4
    xor r4,{acc[5]}
    bis r15,{acc[5]}

    swpb {acc[6]}
    mov.b {acc[6]},r15
    xor r15,{acc[6]}
    bis r4,{acc[6]}

    swpb {acc[7]}
    mov.b {acc[7]},r4
    xor r4,{acc[7]}
    bis r15,{acc[7]}

    pop r15

    mov {acc[0]},2*0({c})
    mov {acc[1]},2*1({c})
    mov {acc[2]},2*2({c})
    mov {acc[3]},2*3({c})
    mov {acc[4]},2*4({c})
    mov {acc[5]},2*5({c})
    mov {acc[6]},2*6({c})
    mov {acc[7]},2*7({c})

    sub #2*8,{c}
"""

JUST_COPY = """
    mov {acc[0]},2*8({c})
    mov {acc[1]},2*9({c})
    mov {acc[2]},2*10({c})
    mov {acc[3]},2*11({c})
    mov {acc[4]},2*12({c})
    mov {acc[5]},2*13({c})
    mov {acc[6]},2*14({c})
    mov {acc[7]},2*15({c})
"""

JUST_XOR = """
    xor {acc[0]},2*8({c})
    xor {acc[1]},2*9({c})
    xor {acc[2]},2*10({c})
    xor {acc[3]},2*11({c})
    xor {acc[4]},2*12({c})
    xor {acc[5]},2*13({c})
    xor {acc[6]},2*14({c})
    xor {acc[7]},2*15({c})
"""

SHIFT_FAST_KARATSUBA_XORS = r"""
    /* SHIFT_FAST_KARATSUBA_XORS */
    xor @{c}+,{acc[0]}
    xor @{c}+,{acc[1]}
    xor @{c}+,{acc[2]}
    xor @{c}+,{acc[3]}
    xor @{c}+,{acc[4]}
    xor @{c}+,{acc[5]}
    xor @{c}+,{acc[6]}
    xor @{c}+,{acc[7]}
    sub #2*8,{c}
"""


ADD = r"""
    /* ADD */
    add #{offset},{r}
"""

SUB = r"""
    /* SUB */
    sub #{offset},{r}
"""

BENCH_RESET = r"""
    mov #0x50,&0x01b0
"""

BENCH_START = r"""
    mov #0x51,&0x01b0
"""

BENCH_STOP = r"""
    mov #0x52,&0x01b0
"""

BENCH_PRINT = r"""
    mov #0x53,&0x01b0
"""
